import type { Exactly, Query, QueryResponse } from './queryTypes.ts';
/**
 * The purpose of these sanity checks:
 * If we make changes and something breaks, our build will fail.
 *
 * AFAIK we _could_ write this in our `tests` folder.
 * The latest version of `vitest` does support `assertType`, but:
 *  * it's easy to get false positives if configured incorrectly
 *  * the api is more vebose than this
 */
export declare function dummyQuery<Q extends Query>(_query: Exactly<Query, Q>): QueryResponse<Q, unknown>;
export interface ExUser {
    name: string;
}
export interface ExPost {
    title: string;
}
interface ExSchema {
    users: ExUser;
    posts: ExPost;
}
export declare function dummySchemaQuery<Q extends Query>(_query: Exactly<Query, Q>): QueryResponse<Q, ExSchema>;
export {};
//# sourceMappingURL=sanityCheckQueries.d.ts.map